package org.apache.bcel.classfile;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.DataInput;
import java.io.DataOutputStream;
import java.io.IOException;
import org.apache.bcel.classfile.Attribute;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.Visitor;

public final class SourceFile extends Attribute {
  private int sourceFileIndex;
  
  SourceFile(int nameIndex, int length, DataInput input, ConstantPool constantPool) throws IOException {
    this(nameIndex, length, input.readUnsignedShort(), constantPool);
  }
  
  public SourceFile(int nameIndex, int length, int sourceFileIndex, ConstantPool constantPool) {
    super((byte)0, nameIndex, length, constantPool);
    this.sourceFileIndex = sourceFileIndex;
  }
  
  public SourceFile(org.apache.bcel.classfile.SourceFile c) {
    this(c.getNameIndex(), c.getLength(), c.getSourceFileIndex(), c.getConstantPool());
  }
  
  public void accept(Visitor v) {
    v.visitSourceFile(this);
  }
  
  public Attribute copy(ConstantPool constantPool) {
    return (Attribute)clone();
  }
  
  public void dump(DataOutputStream file) throws IOException {
    super.dump(file);
    file.writeShort(this.sourceFileIndex);
  }
  
  public int getSourceFileIndex() {
    return this.sourceFileIndex;
  }
  
  public String getSourceFileName() {
    return getConstantPool().getConstantUtf8(this.sourceFileIndex).getBytes();
  }
  
  public void setSourceFileIndex(int sourceFileIndex) {
    this.sourceFileIndex = sourceFileIndex;
  }
  
  public String toString() {
    return "SourceFile: " + getSourceFileName();
  }
}
